@use crate::templates::base;
@use crate::reverse_dependencies::CratePageRevDeps;
@use crate::Urler;
@use kitchen_sink::DependencyKind;

@(url: &Urler, p: &CratePageRevDeps)

@:base(&p.page(), {
  <header id="rev-deps" @if p.ver.is_yanked() {class="yanked"} else {@if p.ver.is_nightly() {class="nightly"}}>
    <div class="inner-col">
    <div class="breadcrumbs">
      <a href="/"><span>Lib</span>.rs</a> ›
    <h1>
     <a href="@url.krate(&p.ver)" rel="up">@p.ver.capitalized_name()</a>
    </h1>
     › Reverse dependencies
    </div>
    </div>
  </header>
  <main>
    <div class="inner-col">
      @if let Some((g, years)) = p.changes_graph() {
        <div class="active-users @if g.len() >= 48 {big}"><table>
          <caption><strong>Active</strong> direct dependers over time: total, gained/lost</caption>
          <tr class=total>
            @for ch in &g {
              <td>@if !ch.label_inside {<span>@ch.running_total</span>}
                @if ch.running_total > 0 {<div class="@if ch.added > ch.removed {gaining} @if ch.added < ch.removed {losing}"
                    style="width: @(ch.width)px; height: @(ch.running_totals_height)px">@if ch.label_inside {<span>@ch.running_total</span>}</div>}
              </td>
            }
          </tr>
          <tr>
            @for (year, colspan) in years {
              <th colspan=@colspan @if colspan < 8 {class="partial"}>@if colspan > 2 {@year}</th>
            }
          </tr>
          <tr class=added>
            @for ch in &g {
              <td>@if ch.added_height > 0 {<div style="width: @(ch.width)px; height: @(ch.added_height-1)px"></div>}</td>
            }
          </tr>
          <tr class=removed>
            @for ch in &g {
              <td>@if ch.removed_height > 0 {<div style="width: @(ch.width)px; height: @(ch.removed_height-1)px"></div>}</td>
            }
          </tr>
        </table></div>
      }

      @if let Some(stats) = p.stats {
        <p>
          @if stats.runtime.all() > 0 {
            <a href="@url.krate(&p.ver)" rel="up">@p.ver.capitalized_name()</a> is used at run time in <b>@p.format_number(stats.runtime.all())</b> crate@if stats.runtime.all() != 1 {s}@if stats.runtime.all() > u32::from(stats.direct.runtime) {
              (@if stats.runtime.opt > 0 {of which @p.format_number(stats.runtime.opt) optionally, }@p.format_number(stats.direct.runtime) directly)}.
          }

          @if stats.build.all() > 0 {
            It's used at build time in <b>@p.format_number(stats.build.all())</b> crate@if stats.build.all() != 1 {s}@if stats.build.all() > u32::from(stats.direct.build) {
              (@if stats.build.opt > 0 {of which @p.format_number(stats.build.opt) optionally, }@p.format_number(stats.direct.build) directly)}.
          }

          @if stats.dev > 0 {
            It's used only as a dev dependency in <b>@p.format_number(stats.dev)</b> crate@if stats.dev != 1 {s}@if stats.dev > stats.direct.dev && stats.direct.dev > 0 {
            (@p.format_number(stats.direct.dev) directly)}.
          }
        </p>

        @if stats.versions.len() > 1 {
          <table class="version-pop">
            <thead><th>Number of dependers</th><th>@p.ver.capitalized_name() version</th><th>Downloads/month</th></thead>
            @for x in p.version_breakdown() {
              <tr>
                <td class="rv">@if x.num == 0 || x.perc <= x.num_width {@x.num_str} @if x.num > 0 {<span style="width:@x.perc%">@if x.perc > x.num_width {@x.num_str}</span>}</td>
                <th>@x.ver</th>
                <td class="dl">
                  @if x.dl > 0 {
                    <span style="width:@x.dl_perc%">@if x.dl_perc > x.dl_num_width {@x.dl_str.0<b>@x.dl_str.1</b>}</span>
                  }
                  @if x.dl == 0 || x.dl_perc <= x.dl_num_width {@x.dl_str.0<b>@x.dl_str.1</b>}
                </td>
            }
          </table>
        }
      }

      @if !p.deps.is_empty() {
        <table class="reverse-deps @if !p.has_download_columns {no-dl-columns}">
          <thead>
              <tr><th colspan="3">Depender
                @if p.has_download_columns {<small>(with downloads and own rev deps)</small>}
              </th> <th colspan="2">@p.ver.capitalized_name() version</th></tr>
          </thead>
          @for r in &p.deps {
            <tr>
              <td>@if r.downloads > 100 {
                <span class=downloads>@if let Some((num,unit)) = Some(p.downloads(r.downloads)) {@num<b>@unit</b>}</span>
              }</td>
              <td>@if r.rev_dep_count > 0 {
                @if let Some(link) = url.reverse_deps(&r.origin) {<a href="@link">@r.rev_dep_count</a>}}</td>
              <td><a href="@url.crate_by_origin(&r.origin)">@r.depender.name()</a></td>
              <td>@if r.is_optional {<span class=feature>optional</span>}
             @if r.kind != DependencyKind::Normal {<span class="label label-@p.kind(r.kind)">@p.kind(r.kind)</span>}</td>
              <td @if !r.matches_latest {class="outdated"}>@r.req</td>
            </tr>
          }
        </table>
      } else {
        <p>This crate isn't used by any other public crates. <a href="@url.krate(&p.ver)" rel="up">Go back to @p.ver.capitalized_name()</a>.</p>
      }
    </div>
  </main>

  <footer>
    <div class="inner-col">
        <p><a href="/revdeps">How this data is computed</a>. Back to <a href="@url.krate(&p.ver)" rel="up">@p.ver.capitalized_name()</a>.</p>
    </div>
  </footer>
})
